<!doctype html>
<html lang="en">
  <head>
    <!-- Required meta tags -->
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

    <!-- Bootstrap CSS -->
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css" integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T" crossorigin="anonymous">

    <!-- JQuery -->
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.4.1/jquery.min.js"></script>
    
  

    <title>Books API</title>
  </head>
  <body style="background-color:cornflowerblue;">
        <!-- Button trigger modal -->
        <button onclick="modal()" id="modal_button" style="float: right;" type="button" class="btn btn-secondary" data-toggle="modal" data-target="#exampleModal">
            Top 5 Liked Books
        </button>
        
        <!-- Modal -->
        <div style="width: 100%;" class="modal fade" id="exampleModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
            <div class="modal-dialog" role="document">
            <div class="modal-content">
                <div class="modal-header">
                <h5 class="modal-title" id="exampleModalLabel">Top 5 Books</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
                </div>
                <div class="modal-body">
                    <div id="modallist"></div>
                </div>
                <div class="modal-footer">
                <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                </div>
            </div>
            </div>
        </div>

        <h1 style="text-align: center;margin-left: 100px;">Google API Book Finder</h1><br>
        
        <div style="justify-content: center;" class="container">
        <div class="input-group mb-3">
            <input type="text" class="form-control" placeholder="Title or Author" id="search">
            <div class="input-group-append">
              <button  onclick="bookSearch()" class="btn btn-secondary" type="button" id="submit">Button</button>
            </div>
          </div>
        </div>  
          
        <table class="table" style="width: 99%; border: 1px solid black; margin-left: 7px; background-color:aliceblue;" id="table">
            <tr style="background-color:gray; border: 1px solid black; border-top: 1px solid black; text-align: center;">
                <th style='border: 1px solid black;'>Title</th>
                <th style='border: 1px solid black;'>Authors</th>
                <th style='border: 1px solid black;'>Likes</th>
            </tr>
        </table>
        

    
    <!-- Optional JavaScript -->
    <!--  then Popper.js, then Bootstrap JS -->
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.14.7/umd/popper.min.js" integrity="sha384-UO2eT0CpHqdSJQ6hJty5KVphtPhzWj9WO1clHTMGa3JDZwrnQq4sF86dIHNDz0W1" crossorigin="anonymous"></script>
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/js/bootstrap.min.js" integrity="sha384-JjSmVgyd0p3pXB1rRibZUAYoIIy6OrQ6VrjIEaFf/nJGzIxFDsf4x0xIM+B07jRM" crossorigin="anonymous"></script>

    <script type="text/javascript">
        function bookSearch(){
            var search= document.getElementById('search').value
            //document.getElementById('results').innerHTML=""
            console.log(search)

            $.ajax({
                url:"https://www.googleapis.com/books/v1/volumes?q=" + search,
                dataType:"json",

                success: function(data){
                    var book_data=''
                    var table_header='<tr style="background-color:gray; border: 1px solid black; border-top: 1px solid black; text-align:center;"><th style="border: 1px solid black;">Title</th><th style="border: 1px solid black;">Author</th><th style="border: 1px solid black;">Likes</th>'
                    for(i=0; i< data.items.length; i++){
                        book_data += "<tr style='border: 1px solid black;'>";
                        book_data += "<td id='title"+i+"' style='border: 1px solid black; text-align:center; font-size:20px'>" + data.items[i].volumeInfo.title + "</td>";
                        if(typeof data.items[i].volumeInfo.authors=='undefined'){
                            book_data += "<td id='author"+i+"' style='border: 1px solid black; text-align:center; font-size:20px'>No Author Data</td>";
                        }
                        else{
                            book_data += "<td id='author"+i+"' style='border: 1px solid black; text-align:center; font-size:20px'>" + data.items[i].volumeInfo.authors + "</td>";
                        }
                        
                        book_data += "<td style='border: 1px solid black; text-align:center;'>"+"<p style='' id='likes" + i + "'>0</p>"+ "<button class='btn btn-secondary' id='button" + i + "' onclick=incrementLike('likes" + i + "')>Like</button>" + "</td>";
                        book_data += "</tr>";

                    }
                    $('#table').empty();
                    $('#table').append(table_header);
                    $('#table').append(book_data);
                },
                type: "GET"
            });
        }

        function incrementLike(i){
            var curLike= parseInt(document.getElementById(i).textContent)
            document.getElementById(i).innerHTML= curLike+1
            console.log(curLike)
        }

        function sortTable(a) {
            var table, rows, switching, i, x, y, shouldSwitch;
            table = a;
            switching = true;
            while (switching) {
                switching = false;
                rows = table.rows;
        
                for (i = 1; i < (rows.length - 1); i++) {
                
                    shouldSwitch = false;
                    x= parseInt(rows[i].cells[2].textContent)
                    y= parseInt(rows[i + 1].cells[2].textContent)

                    if (x < y) {
                        shouldSwitch = true;
                        break;
                    }
                }
                if (shouldSwitch) {
                rows[i].parentNode.insertBefore(rows[i + 1], rows[i]);
                switching = true;
                }
            }
        }

        function modal(){
            console.log('inside modal')
            sortTable(document.getElementById('table'));
            var table= document.getElementById('table');
            var tablerow= table.rows;
            var list=document.getElementById('modallist')
            list.innerHTML=""
            for(i =0; i<5; i++){
                list.innerHTML += "<h2 id='top"+i+"' style='font-size: 20px;'>"+(i+1)+". " + tablerow[i+1].cells[0].textContent + "</h2>";
            }
               
            console.log('finish modal')
            }
    </script>
    
  </body>
</html>